#include "boite.h"
#include <GL/gl.h>

	
pBoite creeBoite (float l, float h, float p, int cullFace, int filaire) {

	pBoite b = (pBoite) malloc (sizeof(tBoite));
	
	b->l=l; b->h=h; b->p=p; b->cullFace=cullFace; b->filaire=filaire;
	
	return b;
}

void traceBoite (pBoite b) {

	float orientation = 1.;
	float specular [] = {0.9,0.9,0.9,1.};
	float shininess = 70.;
	
	glEnable(GL_COLOR_MATERIAL);
	glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
	
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, specular);
	glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, shininess);
	
	if (b->cullFace && !b->filaire) {
		glEnable(GL_CULL_FACE);
		glCullFace(GL_BACK);
		orientation = -1.;
	}
	
	if (b->filaire) {
		glPolygonMode (GL_FRONT_AND_BACK, GL_LINE);
		glLineWidth (2.);		
	}
	
	glColor3f (0.3,0.3,0.6);
	glBegin (GL_QUADS);
	
	/* face arriere */
		glNormal3f(0.,0.,orientation*-1.);
		glVertex3f(0.,0.,0.);
		glVertex3f(b->l,0.,0.);
		glVertex3f(b->l,b->h,0.);
		glVertex3f(0.,b->h,0.);
	/* face avant */
		glNormal3f(0.,0.,orientation);
		glVertex3f(0.,0.,b->p);
		glVertex3f(0.,b->h,b->p);
		glVertex3f(b->l,b->h,b->p);
		glVertex3f(b->l,0.,b->p);
	/* face gauche */
		glNormal3f(orientation*-1.,0.,0.);
		glVertex3f(0.,0.,0.);
		glVertex3f(0.,b->h,0.);
		glVertex3f(0.,b->h,b->p);
		glVertex3f(0.,0.,b->p);
	/* face droite */
		glNormal3f(orientation,0.,0.);
		glVertex3f(b->l,0.,0.);
		glVertex3f(b->l,0.,b->p);
		glVertex3f(b->l,b->h,b->p);
		glVertex3f(b->l,b->h,0.);
	/* face bas */
		glNormal3f(0.,orientation*-1.,0.);
		glVertex3f(0.,0.,0.);
		glVertex3f(0.,0.,b->p);
		glVertex3f(b->l,0.,b->p);
		glVertex3f(b->l,0.,0.);
	/* face haut */
		glNormal3f(0.,orientation,0.);
		glVertex3f(0.,b->h,0.);
		glVertex3f(b->l,b->h,0.);
		glVertex3f(b->l,b->h,b->p);
		glVertex3f(0.,b->h,b->p);
		
		
	glEnd ();

	if (b->cullFace && !b->filaire) glDisable(GL_CULL_FACE);
	
	if (b->filaire) {
		glPolygonMode (GL_FRONT_AND_BACK, GL_FILL);
		glLineWidth (1.);		
	}
	
	glDisable(GL_COLOR_MATERIAL);
}
