#include "bspline.h"
#include <malloc.h>
#include <stdio.h>

struct Sbspline {
  GLfloat *ptsControle; /* vecteur de points de controle rangés x,y,z,... */
  int n; /* n+1 points de controle */
  int k; /* ordre */
  int m; /* degre */
  float *vecNodal;
  float def[2];
  
  GLfloat *ptsCourbe;
  int nbPtsCourbe; 
  
  float *ptsFloraison;
  
  GLuint *indexPolyControl;
  GLuint *indexCourbe;
};

Bspline creerBsplineUniforme (GLfloat *ptsControle, int nbPtsControle, int k) {
  Bspline b = (Bspline)malloc(sizeof(struct Sbspline));
  int i;
  
  b->ptsControle = (GLfloat*)malloc(sizeof(GLfloat)*nbPtsControle*3);
  for(i=0;i<nbPtsControle*3;i++) b->ptsControle[i] = ptsControle[i]; 
  
  b->ptsFloraison = (float*)malloc(sizeof(float)*k*3);
  
  b->vecNodal = (float*)malloc(sizeof(float)*(nbPtsControle+k));
  for (i=0;i<nbPtsControle+k;i++) b->vecNodal[i] = (float)i;
  
  b->def[0] = b->vecNodal[k-1];
  b->def[1] = b->vecNodal[nbPtsControle];
  
  b->indexPolyControl = (GLuint*)malloc(sizeof(GLuint)*nbPtsControle);
  for(i=0;i<nbPtsControle;i++) b->indexPolyControl[i] = (GLuint)i; 
  
  b->k = k;
  b->m = k-1;
  b->n = nbPtsControle-1;
  
  return b;
}

void calculCourbeBspline (Bspline b, int nbPtsCourbe) {
  int i;
  float u;
  float pas = (b->def[1] - b->def[0]) / ((float)nbPtsCourbe-1.);
  float eps = pas*0.1;
  
  b->ptsCourbe = (GLfloat*)malloc(sizeof(GLfloat)*nbPtsCourbe*3);
  b->indexCourbe = (GLuint*)malloc(sizeof(GLuint)*nbPtsCourbe);
  for (i=0;i<nbPtsCourbe;i++) b->indexCourbe[i] = (GLuint)i;
  
  b->nbPtsCourbe = nbPtsCourbe;
  
  i=0;
  for (u=b->def[0];u<=b->def[1];u+=pas) {
    evalBspline (b,u,&b->ptsCourbe[i*3]);
    i++;
  } 
  evalBspline (b,b->def[1],&b->ptsCourbe[i*3]);
}

void affichePolyControleBspline (Bspline b){
	glColor3f (1.,1.,1.);
	
	glEnableClientState (GL_VERTEX_ARRAY);
	
	glVertexPointer (3,GL_FLOAT,0,b->ptsControle);
	
	glLineWidth (1.);
	
	glDrawElements (GL_LINE_STRIP,b->n+1,GL_UNSIGNED_INT,b->indexPolyControl);
	
	glDisableClientState (GL_VERTEX_ARRAY);
}

void afficheCourbeBspline (Bspline b) {
        int i;
	
	glColor3f (1.,0.,0.);
	
	glEnableClientState (GL_VERTEX_ARRAY);
	
	glVertexPointer (3,GL_FLOAT,0,b->ptsCourbe);
	
	glLineWidth (1.);
	
	glDrawElements (GL_LINE_STRIP,b->nbPtsCourbe,GL_UNSIGNED_INT,b->indexCourbe);
	
	glDisableClientState (GL_VERTEX_ARRAY);
  
}

void evalRecBspline (Bspline b, float u, Point p, int dec, int k) {
  
}

void evalBspline (Bspline b, float u, Point p) {

}